## lintian4python 0.28.1

=== tests/Makefile ===
.PHONY: test-local
test-local:
	$(MAKE) -C code-analysis/ PYTHON=python test-local
	$(MAKE) -C code-analysis/ PYTHON=python3 test-local
	$(MAKE) -C blackbox/ test-local

.PHONY: test-installed
test-installed:
	$(MAKE) -C code-analysis/ PYTHON=python test-installed
	$(MAKE) -C code-analysis/ PYTHON=python3 test-installed
	$(MAKE) -C blackbox/ test-installed

# vim: syntax=make ts=4 sw=4 noet

=== tests/blackbox/Makefile ===
.PHONY: test-local
test-local:
	export PATH="$(CURDIR)/../..:$$PATH" && \
	./run-tests --verbose

.PHONY: test-installed
test-installed:
	./run-tests --verbose

# vim: syntax=make ts=4 sw=4 noet

=== tests/code-analysis/Makefile ===
PYTHON2S = $(shell pyversions -i)
PYTHON3S = $(shell py3versions -i)
PYTHONS = $(PYTHON2S) $(PYTHON3S)

for_all_pythons = echo $(PYTHONS) | xargs -n1 | xargs -t -I {} env {}

.PHONY: test-local
test-local:
	export LINTIAN_ROOT=../../ && \
	$(for_all_pythons) ./run-tests --verbose

.PHONY: test-installed
test-installed:
	$(for_all_pythons) ./run-tests --verbose

# vim: syntax=make ts=4 sw=4 noet

## lintian4python 0+20120317

=== debian/changelog ===
lintian4python (0+20120317) experimental; urgency=low

  * Initial release.
  * Summary of tag changes:
    + Added:
      - SOURCES.txt-in-binary-package
      - cannot-parse-python-central-metadata
      - egg-info-version-mismatch
      - extension-uses-old-pyrex-import-type
      - incorrect-team-name
      - incorrect-vcs-field
      - missing-dependency-for-import
      - missing-requires.txt-dependency
      - missing-requires.txt-optional-dependency
      - missing-vcs-field
      - pth-file-modifies-sys.path
      - pyflakes-duplicate-argument
      - pyflakes-import-shadowed-by-loop-var
      - pyflakes-import-star-used
      - pyflakes-late-future-import
      - pyflakes-redefined-function
      - pyflakes-redefined-while-unused
      - pyflakes-undefined-export
      - pyflakes-undefined-local
      - pyflakes-undefined-name
      - pyflakes-unused-import
      - pyflakes-unused-variable
      - python-central-metadata-for-missing-files
      - python-depends-but-no-python-helper
      - python-module-but-no-python-depends
      - syntax-error
      - unknown-optional-project-in-requires.txt
      - unknown-project-in-requires.txt

 -- Jakub Wilk <jwilk@debian.org>  Sat, 17 Mar 2012 22:41:38 +0100

=== debian/control ===
Source: lintian4python
Section: devel
Priority: extra
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.3

Package: lintian4python
Architecture: all
Depends: ${misc:Depends},
 lintian (>= 2.5.5~), lintian (<< 2.5.6+),
 libmonkey-patch-perl,
 python, pyflakes (>= 0.5.0), pyflakes (<< 0.5.0+)
Description: Debian package checker (for Python packages)
 Lintian dissects Debian packages and reports bugs and policy
 violations. It contains automated checks for many aspects of Debian
 policy as well as some checks for common errors.
 .
 This package provides an experimental flavor of lintian designed to check
 packages implemented in Python.

=== debian/rules ===
#!/usr/bin/make -f

directories = checks collection data helpers lib profiles
share = /usr/share/lintian4python/

.PHONY: clean
clean:
	dh_testdir
	dh_clean

.PHONY: build build-arch build-indep

.PHONY: binary binary-arch binary-indep
binary binary-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_install $(directories) $(share)
	dh_install lintian4py* /usr/bin/
	sed -i -e "s,\($$ENV{'LINTIAN_ROOT'}\) = .*,\1 = '$(share)';," debian/*/usr/bin/*
	dh_installdocs
	dh_installchangelogs
	dh_lintian
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# vim:ts=4 sw=4 noet

## lintian4python 0.8.2

=== debian/changelog ===
lintian4python (0.8.2) experimental; urgency=low

  * checks/bytecompilation:
    + Fix the regexp that was meant to exclude file in /usr/bin/ etc. from
      bytecompilation checks.
    + Exclude /usr/games from bytecompilation checks.
    + Exclude /usr/lib/debug/usr/bin/ etc. from bytecompilation checks.

  * checks/egg-info:
    + Don't define variables inside conditionals.

  * data/python/projects*:
    + Refresh.

  * debian/control:
    + Update lintian dependency (for compatibility with 2.5.10.2).

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 17 Sep 2012 17:18:27 +0200

lintian4python (0.8.1) experimental; urgency=low

  * data/python/projects*:
    + Refresh.
  * data/python/sys.path-additions*:
    + Refresh.

  * checks/bytecompilation:
    + Don't complain about .py files in /etc that are not byte-compiled.
    + Don't complain about .py files within standard libraries of alternative
      Python interpreters (jython, pypy) that are not byte-compiled.

  * debian/control:
    + Update lintian dependency (2.5.9, 2.5.10, 2.5.10.1).
  * debian/source/options:
    + Ignore __pycache__ directories when generating tarball.

  * private/misc.py:
    + Split some code from private/refresh-sys.path-additions, which could be
      useful for other private/* scripts in the future, here.
  * private/refresh-sys.path-additions:
    + Use the built-in gzip module instead of spawning an external gzip
      process. (It's a bit slower, but makes the code simpler.)
    + Assume that *-nspkg.pth files don't add anything to sys.path.
    + Output apt progress to stderr (rather than to stdout).
    + Look for .pth files also in /usr/lib/wx/python/.

  * tests/*.tdesc:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 04 Aug 2012 08:55:41 +0200

lintian4python (0.8) experimental; urgency=low

  * Summary of tag changes:
    + misssing-dependency-for-sys.path-addition

  * data/python/projects*:
    + Refresh.
  * data/python/sys.path-additions{,-py3k}:
    + New data files with lists of packages that add extra entries to sys.path
      via .pth files.

  * checks/depends:
    + Add "use strict; use warnings;". Thanks to Niels Thykier for the bug
      report.
  * checks/package-name:
    + Take extra entries to sys.path that could be added via .pth files into
      account.
    + Tighten a regex.
  * checks/pth:
    + Check for missing dependency on a package that provides a sys.path
      addition, which is needed for the shipped modules to be importable.

  * private/refresh-python-projects:
    + Use http.debian.net as the default mirror.
  * private/refresh-sys.path-additions
    + New script to update data/python/sys.path-additions*.

  * tests/*.tdesc:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 11 Jul 2012 22:40:30 +0200

lintian4python (0.7) experimental; urgency=low

  * Summary of tag changes:
    + hardcoded-dependency-on-numpy-virtual-package

  * checks/depends:
    + Port to the Lintian::Relation::visit API.
    + Check for hardcoded dependency on Numpy virtual packages.

  * data/python/projects*:
    + Refresh.

  * debian/control:
    + Update lintian dependency (2.5.9, 2.5.10).

  * tests/*.tdesc:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 30 Jun 2012 19:31:34 +0200

lintian4python (0.6) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      + incorrect-package-name
      + sphinx-cruft-in-binary-package

  * checks/documentation:
    + Add tag descriptions for
      rst-source-referenced-by-searchindex.js-does-not-exist and
      rst-source-referenced-by-searchindex.js-is-compressed.
    + Check for Sphinx cruft in binary packages.

  * checks/scripts:
    + Fix false positive versioned-python-shebang for idle-python2.X packages.

  * checks/package-name:
    + Check if package names conform to Python Policy §2.2.

  * data/python/projects*:
    + Refresh.

  * tests/*.tdesc:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 27 Jun 2012 20:11:04 +0200

lintian4python (0.5) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - cannot-parse-sphinx-searchindex.js
      - extension-is-symlink
      - inconsistent-use-of-tabs-and-spaces-in-indentation
      - js-file-referenced-by-search.html-does-not-exist
      - js-file-referenced-by-search.html-is-compressed
      - pyflakes-undefined-name-underscore
      - python-breaks-is-obsolete
      - rst-source-referenced-by-searchindex.js-does-not-exist
      - rst-source-referenced-by-searchindex.js-is-compressed
      - search.html-doesnt-load-search-index
      - search.html-references-nonlocal-js-file
      - search.html-with-invalid-root-url
      - search.html-with-non-local-root-url
      - sphinx-js-incompatible-with-jquery-1.4
      - sphinx-js-incompatible-with-jquery-1.5
      - sphinx-js-with-jinja2-templates
      - static-extension
      - substitution-variable-in-xs-python-version

  * checks/*:
    + Port to Lintian 2.5.9 API.

  * checks/code-analysis:
    + Check for inconsistent use of tabs and spaces in indentation.
    + Fix a typo.

  * checks/documentation:
    + Check for search.html (generated by Sphinx):
      - referencing nonexistent .js (or compressed) files;
      - referencing non-local .js files;
      - failing to load search index;
      - with non-local or invalid root URL;
    + Check for Sphinx .js code:
      - incompatible with recent (1.4, 1.5) jQuery versions;
      - containing (unexpanded) Jinja2 templates;
      - referencing nonexistent rST source files.

  * checks/extensions:
    + Check for static extension modules.
    + Check for extensions that are symlinks (e.g. _eggs.so ->
      _eggs.so.1.0.0).

  * checks/helpers:
    + Check for ${python:Breaks}.
    + Check for substitution variables in XS-Python-Version.

  * checks/imports:
    + Fix a typo.

  * checks/pyflakes:
    + Do not emit pyflakes-undefined-name for "_" (underscore) in private


=== debian/control ===
--- 
+++ 
@@ -4,13 +4,18 @@
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7)
 Standards-Version: 3.9.3
+Vcs-Hg: https://bitbucket.org/jwilk/lintian4python
+Vcs-Browser: https://bitbucket.org/jwilk/lintian4python
 
 Package: lintian4python
 Architecture: all
-Depends: ${misc:Depends},
- lintian (>= 2.5.5~), lintian (<< 2.5.6+),
+Depends: ${misc:Depends}, ${perl:Depends},
+ lintian (>= 2.5.9~), lintian (<< 2.5.10.2+),
  libmonkey-patch-perl,
- python, pyflakes (>= 0.5.0), pyflakes (<< 0.5.0+)
+ perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
+ python (>= 2.6), pyflakes (>= 0.5.0), pyflakes (<< 0.5.0+)
+Recommends:
+ python3
 Description: Debian package checker (for Python packages)
  Lintian dissects Debian packages and reports bugs and policy
  violations. It contains automated checks for many aspects of Debian

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,8 @@
 #!/usr/bin/make -f
 
-directories = checks collection data helpers lib profiles
+directories = checks collection helpers lib libextra profiles vendors
 share = /usr/share/lintian4python/
+version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version))
 
 .PHONY: clean
 clean:
@@ -17,7 +18,11 @@
 	dh_prep
 	dh_install $(directories) $(share)
 	dh_install lintian4py* /usr/bin/
-	sed -i -e "s,\($$ENV{'LINTIAN_ROOT'}\) = .*,\1 = '$(share)';," debian/*/usr/bin/*
+	sed -i \
+		-e "s,\($$ENV{'LINTIAN_ROOT'}\) = .*,\1 = '$(share)';," \
+		-e "s,\(\$$lintian4python_version\) = undef;,\1 = '$(version)';," \
+		debian/*/usr/bin/*
+	dh_perl
 	dh_installdocs
 	dh_installchangelogs
 	dh_lintian

## lintian4python 0.11

=== debian/changelog ===
lintian4python (0.11) experimental; urgency=low

  * debian/control:
    + Update lintian dependency (2.5.11).

  * checks/*:
    + Port to Lintian 2.5.11 API.

  * libextra/Lintian/Python.pm:
    + Port to Lintian 2.5.11 API.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 14 Dec 2012 22:42:09 +0100

lintian4python (0.10.2) experimental; urgency=low

  * Brown paper bag upload.

  * debian/control:
    + Update lintian dependency (it is NOT compatible with 2.5.11 yet).
      Thanks to Niels Thykier for making me realize the mistake.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 12 Dec 2012 16:07:42 +0100

lintian4python (0.10.1) experimental; urgency=low

  * debian/control:
    + Update lintian dependency (for compatibility with 2.5.11).
    + Bump standards version to 3.9.4; no changes needed.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 12 Dec 2012 14:50:53 +0100

lintian4python (0.10) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - python-module-in-multi-arch-foreign-package
    + Removed:
      - extension-in-multi-arch-foreign-package

  * checks/extensions:
    + Remove the check for "Multi-Arch: foreign" packages shipping extension
      modules (it hasn been replaced by a more generic check).

  * checks/multi-arch:
    + Check for "Multi-Arch: foreign" packages shipping Python modules.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 03 Dec 2012 19:36:04 +0100

lintian4python (0.9) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - extension-in-multi-arch-foreign-package

  * checks/extensions:
    + Check for "Multi-Arch: foreign" packages shipping extension modules.

  * data/python/projects*:
    + Refresh.

  * debian/lintian4python.lintian-overrides:
    + Add override for pyflakes-redefined-function.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 18 Oct 2012 11:25:19 +0200

## lintian4python 0.13.1

=== debian/changelog ===
lintian4python (0.13.1) experimental; urgency=low

  * checks/python/package-name:
    + Fix regexp, so that Python 3 extensions modules are taken into account.

  * data/python*-projects:
    + Refresh.

  * private/refresh-python-projects:
    + Consider packages from both unstable and experimental.

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 17 Jan 2013 23:19:58 +0100

lintian4python (0.13) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - source-contains-sphinx-cache

  * checks/bytecompilation:
    + Bump source-contains-python-bytecode severity to normal.
  * checks/documentation:
    + Check for source packages containing Sphinx cache files.

  * private/update-coverage:
    + Look into the checks/python/ directory.

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 11 Jan 2013 14:55:08 +0100

lintian4python (0.12) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - source-contains-python-bytecode

  * checks/*:
    + Move the checks to the python/ subdirectory.
      Thanks to Niels Thykier for the bug report.
    + Change check name abbreviations so that they all start with “py”.
    
  * checks/python/bytecompilation:
    + Check for source package containing .pyc and .pyo files.

  * data/*:
    + Fix broken symlinks.
    + Rename data files:
      - python/exceptions → python-exceptions
      - python/projects → python2-projects
      - python/projects-py3k → python3-projects
      - python/sys.additions → python3-sys.additions
      - python/sys.additions-py3k → python3-sys.additions
  * data/python/python*-projects:
    + Refresh.

  * debian/copyright:
    + Update copyright years.
  * debian/rules:
    + Don't install ‘libextra’; it's been superseded by ‘lib’.
  * debian/*.lintian-overrides:
    + Update.
  * debian/postinst, debian/postrm, debian/prerm:
    + Add code to handle /usr/share/lintian4python/lib switch from being
      symlink to regular directory.

  * lib, libextra:
    + Remove /usr/share/lintian/lib symlink; it's no longer needed, as Lintian
      Perl modules are now public. Rename ‘libextra’ as ‘lib’ instead.

  * lintian4py, lintian4py-info:
    + Use --profile debian/python.
    + Don't modify @INC, no longer needed.

  * profiles/:
    + Rename the ‘main’ profile as ‘python’.

  * tests/*:
    + New tests.
    + Make it possible to run tests against multiple packages at once.
      Thanks to Niels Thykier for the bug report.

  * vendors/:
    + Rename the ‘main’ profile as ‘python’.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 04 Jan 2013 19:08:22 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: extra
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7)
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Vcs-Hg: https://bitbucket.org/jwilk/lintian4python
 Vcs-Browser: https://bitbucket.org/jwilk/lintian4python
 
 Package: lintian4python
 Architecture: all
 Depends: ${misc:Depends}, ${perl:Depends},
- lintian (>= 2.5.9~), lintian (<< 2.5.10.2+),
+ lintian (>= 2.5.11), lintian (<< 2.5.12),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
  python (>= 2.6), pyflakes (>= 0.5.0), pyflakes (<< 0.5.0+)

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-directories = checks collection helpers lib libextra profiles vendors
+directories = checks collection helpers lib profiles vendors
 share = /usr/share/lintian4python/
 version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version))

## lintian4python 0.14

=== debian/changelog ===
lintian4python (0.14) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - obsolete-pil-import
      - pyflakes-redefined
      - pyflakes-redefined-in-list-comp
    + Removed:
      - pyflakes-redefined-function

  * COPYING:
    + Add full text of the GPLv2 license.

  * data/python*-projects:
    + Refresh.
  * data/python-imaging-modules:
    + Add list of top-level PIL modules.

  * debian/control:
    + Add the Homepage field.
    + Update pyflakes dependency (0.6.1).
  * debian/lintian4python.lintian-overrides:
    + Drop override for pyflakes-redefined-function (no longer emitted by
      pyflakes 0.6.1).
  * debian/README.source:
    + Ask to change source format when forking.

  * checks/python/pyflakes:
    + Mark pyflakes-import-star-used as experimental.
    + Emit pyflakes-import-star-used at most once per file.
    + Update tags list for pyflakes 0.6.1.
    + Add descriptions to all tags.
  * checks/python/code-analysis:
    + Check for obsolete PIL imports.

  * helpers/code-analysis:
    + Check for obsolete PIL imports.

  * private/refresh-pyflakes-tags:
    + Generate template descriptions for new tags.

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 14 Feb 2013 17:24:07 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Standards-Version: 3.9.4
 Vcs-Hg: https://bitbucket.org/jwilk/lintian4python
 Vcs-Browser: https://bitbucket.org/jwilk/lintian4python
+Homepage: http://jwilk.net/software/lintian4python
 
 Package: lintian4python
 Architecture: all
@@ -13,7 +14,7 @@
  lintian (>= 2.5.11), lintian (<< 2.5.12),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
- python (>= 2.6), pyflakes (>= 0.5.0), pyflakes (<< 0.5.0+)
+ python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.6.1+)
 Recommends:
  python3
 Description: Debian package checker (for Python packages)

## lintian4python 0.15

=== debian/changelog ===
lintian4python (0.15) experimental; urgency=low

  * Summary of tag changes:
    + Removed:
      - search.html-doesnt-load-search-index
    + Added:
      - unneeded-pycentral-pkgremove-in-preinst
      - search.html-does-not-load-search-index

  * data/python*-projects:
    + Refresh.
  * data/python-exceptions:
    + Refresh.

  * checks/python/*:
    + Document Perl version requirements for each Perl module.

  * checks/python/helpers:
    + Fix a typo in debian-pycompat-is-obsolete description.
    + Fix reading changelogs from binary packages.
    + Check for unneeded “pycentral pkgremove” in preinst scripts.

  * checks/python/documentation:
    + Rename search.html-doesnt-load-search-index as
      search.html-does-not-load-search-index.

  * private/*:
    + Document Perl version requirements for each Perl script.
  * private/refresh-exception-names:
    + Scan Python 3.4 documentation, too.

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 21 Feb 2013 18:51:38 +0100

## lintian4python 0.17.1

=== debian/changelog ===
lintian4python (0.17.1) experimental; urgency=low

  * data/python*-projects:
    + Refresh.

  * helpers/code-analysis:
    + Fix compatibility with Python 3.3 (closes: #704250).
      Thanks to Julian Taylor for the bug report.

  * tests/run-tests:
    + Raise a more friendly exception on SHA-1 mismatch.
    + Print a more friendly assertion message when lintian's stderr is
      non-empty.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 04 Apr 2013 22:09:00 +0200

lintian4python (0.17) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - dbg-extension-in-non-dbg-package
      - search.html-references-non-local-file
      - sphinx-static-file-with-jinja2-templates
    + Removed:
      - search.html-references-non-local-js-file
      - sphinx-js-with-jinja2-templates

  * data/python*-projects:
    + Refresh.

  * checks/python/documentation:
    + Remove some unused code.
    + Check for non-local CSS files.
    + Check for CSS files with unexpanded Jinja2 templates.
  * checks/python/egg-info:
    + When comparing egg-info versions with Debian versions:
      - strip various repack suffixes (“debian”, “dfsg”, “ds”, “repack”) in a
        consistent way;
      - handle X.rcY versions correctly (closes: #703572).
      Thanks to Julian Taylor for the bug report.
    + Use common regex from Lintian::Python to select files from dist-packages
      and friends.
    + Skip “test” and “tests” subdirectories.
  * checks/python/extensions:
    + Check for public dbg extension modules in non-dbg packages.
      Thanks to Sebastian Ramacher for the bug report.
  * checks/python/{multi-arch,package-name,pth}
    + Use common regex from Lintian::Python to select files from dist-packages
      and friends.
  * checks/python/pyflakes:
    + Beautify pyflakes-late-future-import output.

  * lib/Lintian/Python.pm:
    + Classify modules in /usr/lib/pyshared/python2.X as public.
    + Add regex for selecting files from dist-packages and friends.

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 22 Mar 2013 22:02:02 +0100

lintian4python (0.16) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - insufficient-build-dependency-on-python-helper
      - missing-build-dependency-on-python-helper
      - missing-versioned-build-dependency-on-python-helper

  * checks/python/code-analysis:
    + Don't emit obsolete-pil-import for packages built from the
      python-imaging source package.
  * checks/python/helpers:
    + Check for insufficient or missing build-dependency on python for
      packages using dh_python2.

  * data/dh-python2-options:
    + New data file that lists new dh_python2 options with versions in which
      they were introduced.
  * data/python*-projects:
    + Refresh.
  * data/python*-sys.path-additions:
    + Refresh.

  * lib/Lintian/Python.pm:
    + Add function python_alt_dep to generate (possibly versioned) dependency
      on python(3), with alternative for other packages that are guaranteed to
      transitively depend on python(3).

  * private/refresh-sys.path-additions:
    + Ignore addition of the PIL directory to sys.path. Future versions for
      PIL won't add this directory, and packages shouldn't rely on it.

  * tests/*:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 11 Mar 2013 22:13:29 +0100

## lintian4python 0.24.4

=== debian/changelog ===
lintian4python (0.24.4) experimental; urgency=low

  * debian/control:
    + Update lintian dependency (2.5.19).

  * debian/rules:
    + Check if binary package dependencies are satisfiable in build
      environment.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 26 Sep 2013 18:31:52 +0200

lintian4python (0.24.3) experimental; urgency=low

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian dependency (2.5.18).

  * lintian4py:
    + Pass --include-dir as the first option.

  * lintian4py-info:
    + Pass --include-dir as the first option.
    + Use exec() instead of do() to call lintian-info.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 24 Sep 2013 17:48:46 +0200

lintian4python (0.24.2) experimental; urgency=low

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian dependency (2.5.17).

 -- Jakub Wilk <jwilk@debian.org>  Sun, 08 Sep 2013 16:49:25 +0200

lintian4python (0.24.1) experimental; urgency=low

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian dependency (2.5.16).

 -- Jakub Wilk <jwilk@debian.org>  Fri, 23 Aug 2013 15:31:18 +0200

lintian4python (0.24) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - http-pypi-url

  * checks/python/watch:
    + Check for HTTP PyPI URLs (closes: #719026). Thanks to Stefano Rivera for
      the bug report.

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update pyflakes dependency (0.7.3).
      Thanks to Paul Wise for the bug report.

  * private/update-coverage:
    + Sort checks.

  * tests/blackbox/watch:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 08 Aug 2013 12:24:32 +0200

lintian4python (0.23.2) experimental; urgency=low

  * debian/control:
    + Update lintian dependency (2.5.15).

  * data/python*-projects:
    + Update.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 23 Jul 2013 17:53:30 +0200

lintian4python (0.23.1) experimental; urgency=low

  * checks/python/*:
    + Rename all checks to include the “.pm” extension.

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian dependency (2.5.14).

 -- Jakub Wilk <jwilk@debian.org>  Sun, 30 Jun 2013 11:04:57 +0200

lintian4python (0.23) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - pyflakes-doctest-syntax-error

  * checks/python/pyflakes:
    + Update for pyflakes 0.7.2.

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update pyflakes dependency.
    + Add “XS-Testsuite: autopkgtest”.

  * debian/tests:
    + Add DEP-8 tests.

  * lib/Lintian/Contrib/Python.pm:
    + Improve dependency analysis for deciding whether a package is
      implemented in Python 2 or Python 3.

  * lintian4py:
    + Set module search path if run locally.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 28 Jun 2013 22:50:35 +0200

lintian4python (0.22) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - missing-dependency-on-ply-virtual-package

  * checks/python/*:
    + Drop the Abbrev field.
  * checks/python/bytecompilation:
    + Remove /usr/lib/debug/usr/lib/pypy/ from the list of directories that
      are not checked for bytecompilation.
  * checks/python/code-analysis:
    + Check for missing dependencies on PLY virtual packages
      (python-ply-{lex,yacc}-X.Y and their python3-* counterparts).

  * debian/control:
    + Add all packages required to run lintian4py to Build-Depends-Indep.
    + Add python-all and python3-all to Build-Depends-Indep.
    + Add python-nose and python3-nose to Build-Depends-Indep.
  * debian/rules:
    + Run code-analysis tests at build time.
    + Run lintian4py against the just-built .deb, as a build-time test.

  * data/python*-projects:
    + Update.

  * helpers/python/code-analysis:
    + Detect Python modules generated by PLY.

  * private/*:
    + Don't use LINTIAN_ROOT environment variable.
  * private/update-code-analysis-tags:
    + Port to Python 3.
    + Update paths.
  * private/update-coverage:
    + Port to Python 3.
    + Update paths.
    + Update coverage for code-analysis helper tests, too.
  * private/update-pyflakes-tags:
    + Port to Python 3.
  * private/update-sys.path-additions:
    + Remove an unused import.

  * tests/code-analysis:
    + New tests for the code-analysis helper.
  * tests/blackbox:
    + Move the old tests here.
    + Change test extension from “.tdesc” to “.t”.
    + Correct some SHA-1 hashes.
    + Don't unset http::Proxy::* APT configuration options. It was previously
      done because some APT proxies don't let through requests to
      http://snapshot.debian.org/. Users of such proxies are advised to add
      the following line to their APT configuration file:
      Acquire::http::Proxy::snapshot.debian.org "DIRECT";
    + Add new tests.
  * tests:
    + Add makefiles to ease running tests.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 20 Jun 2013 23:38:17 +0200

lintian4python (0.21) experimental; urgency=low

  * checks/python/depends:
    + Check for pythonX.Y-* package names in Conflicts, Replaces and Provides
      for X.Y << 2.3, too.
  * checks/python/documentation:
    + Don't use given/when statements. This feature is deemed experimental as
      of Perl 5.18.
  * checks/python/code-analysis:
    + Use Lintian::Util::locate_helper_tool().
  * checks/python/pyflakes:
    + Reduce pyflakes-redefined-in-list-comp certainty to wild-guess (see bug
      #700565).
    + Use Lintian::Util::locate_helper_tool().
  * checks/*:
    + Use Lintian::Contrib::Python instead of Lintian::Python.

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian dependency (2.5.13).
    + Capitalize “Lintian” in the package description.
  * debian/rules:
    + Update to follow the changes in the frontend.
    + Install to /usr/share/lintian/.
    + Don't use dh_testdir; instead, use makefile rules to ensure that
      debian/rules can be only run in the correct directory.



=== debian/control ===
Source: lintian4python
Section: devel
Priority: extra
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 7)
Build-Depends-Indep:
 lintian (>= 2.5.14~), lintian (<< 2.5.20~),
 libmonkey-patch-perl,
 perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
 python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.7.3+),
 python-all, python-nose,
 python3-all, python3-nose,
XS-Testsuite: autopkgtest
Standards-Version: 3.9.4
Vcs-Hg: https://bitbucket.org/jwilk/lintian4python
Vcs-Browser: https://bitbucket.org/jwilk/lintian4python
Homepage: http://jwilk.net/software/lintian4python

Package: lintian4python
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
 lintian (>= 2.5.14~), lintian (<< 2.5.20~),
 libmonkey-patch-perl,
 perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
 python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.7.3+)
Recommends:
 python3
Description: Debian package checker (for Python packages)
 Lintian dissects Debian packages and reports bugs and policy
 violations. It contains automated checks for many aspects of Debian
 policy as well as some checks for common errors.
 .
 This package provides an experimental flavor of Lintian designed to check
 packages implemented in Python.

=== debian/rules ===
#!/usr/bin/make -f

directories = checks helpers lib profiles vendors
share = /usr/share/lintian/
version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version))

.PHONY: clean
clean: debian/control
	dh_clean
	rm -f debian/*-stamp

.PHONY: build build-arch build-indep
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
build build-indep: debian/test-stamp
debian/test-stamp:
	$(MAKE) -C tests/code-analysis/ test-local
	touch $(@)
endif

.PHONY: binary binary-arch binary-indep
binary binary-indep: debian/control
	dh_testroot
	dh_prep
	dh_install $(directories) $(share)
	dh_install lintian4py* /usr/bin/
	sed -i \
		-e "s,\(\$$lintian4python_root\) = .*,\1 = undef;," \
		-e "s,\(\$$lintian4python_version\) = undef;,\1 = '$(version)';," \
		debian/*/usr/bin/*
	dh_perl
	dh_installdocs
	dh_installchangelogs
	dh_lintian
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	mkdir -p debian/tmp
	dh_builddeb --destdir=debian/tmp
	export LINTIAN_INTERNAL_TESTSUITE=1 && \
	./lintian4py --allow-root --no-cfg debian/tmp/*.deb 2>&1 | ( ! grep . )
	dpkg -f debian/tmp/*.deb Depends \
	| xargs -t -d '\n' dpkg-checkbuilddeps -d
endif
	dh_builddeb

# vim:ts=4 sw=4 noet

=== debian/tests/control ===
Tests: code-analysis
Depends: lintian4python,
 make,
 python, python-nose,
 python3, python3-nose

## lintian4python 0.25.1

=== debian/changelog ===
lintian4python (0.25.1) experimental; urgency=low

  * debian/control:
    + Update lintian dependency (2.5.20).

 -- Jakub Wilk <jwilk@debian.org>  Tue, 17 Dec 2013 13:56:03 +0100

lintian4python (0.25) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - string-formatting-error

  * checks/python/bytecompilation:
    + Don't complain about files in /usr/share/paster_templates/ not being
      byte-compiled.
  * checks/python/code-analysis:
    + Check for errors in string formatting (% operator).

  * data/python*-projects:
    + Update.

  * debian/control:
    + Bump standards version to 3.9.5 (no changes needed).
  * debian/copyright:
    + Document the new license for helpers/python/code-analysis.

  * helpers/python/code-analysis:
    + Check for catching string exceptions.
    + Check for errors in string formatting (% operator).
    + Relicense to the Expat license, so that other static analysers can
      incorporate the code easily.

  * private/update-python-projects:
    + Sort alternatives, so that the output is deterministic.
    + Don't assume that the “distribute” project exists.
    + Clean up the code.

  * tests:
    + New tests.
  * tests/blackbox/run-tests:
    + Improve error handling.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 10 Dec 2013 10:36:51 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7)
 Build-Depends-Indep:
- lintian (>= 2.5.14~), lintian (<< 2.5.20~),
+ lintian (>= 2.5.14~), lintian (<< 2.5.21~),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
  python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.7.3+),
  python-all, python-nose,
  python3-all, python3-nose,
 XS-Testsuite: autopkgtest
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Hg: https://bitbucket.org/jwilk/lintian4python
 Vcs-Browser: https://bitbucket.org/jwilk/lintian4python
 Homepage: http://jwilk.net/software/lintian4python
@@ -19,7 +19,7 @@
 Package: lintian4python
 Architecture: all
 Depends: ${misc:Depends}, ${perl:Depends},
- lintian (>= 2.5.14~), lintian (<< 2.5.20~),
+ lintian (>= 2.5.14~), lintian (<< 2.5.21~),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
  python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.7.3+)

## lintian4python 0.28.1

=== debian/changelog ===
lintian4python (0.28.1) experimental; urgency=low

  * checks/python/pth, checks/python/package-name:
    + Correctly handle empty data files.

  * data/python*-sys.path-additions:
    + Update.

  * debian/control:
    + Update (Build-)Depends to support pyflakes 0.8.1 (closes: #743349).
      Thanks to Julian Andres Klode for the bug report.
    + Add python3-debian to Build-Depends.
  * debian/rules:
    + Ensure that .desc files for code-analysis and pyflakes checks are
      up-to-date.
    + Build the binary package exactly once.
  * debian/tests/adequate:
    + Avoid an unnecessary fork.

  * helpers/python/pyflakes:
    + Fix a pyflakes warning.

  * private/aptly.py:
    + Move apt-specific code from misc.py here.
  * private/update-sys.path-additions:
    + Use ‘aptly’ instead of ‘misc’. 
    + Don't blacklist PIL.
    + Blacklist setuptools-*.egg-info.
  * private/update-*-tags:
    + Add the --dry-run option.
    + Exit with non-zero status if the .desc files were not up-to-date.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 02 Apr 2014 00:57:36 +0200

lintian4python (0.28) experimental; urgency=low

  * Summary of tag chanages:
    + Added:
      - syntax-warning
    + Removed:
      - pyflakes-duplicate-argument
      - pyflakes-late-future-import

  * checks/python/pyflakes:
    + Update for pyflakes 0.8.
    + Blacklist syntax error tags; they are better handled by the code-analysis
      check.

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update pyflakes dependency.
  * debian/copyright:
    + Update years.
  * debian/tests:
    + Add test for adequate(1)-cleanness.

  * helpers/python/code-analysis:
    + Byte-compile ASTs to catch more syntax errors.
    + Check for syntax warnings.
  * helpers/python/pyflakes:
    + Blacklist syntax error tags.

  * private/update-code-analysis-tags:
    + Always use UTF-8 for Python source encodings.
  * private/update-pyflakes-tags:
    + Blacklist syntax error tags.

  * tests/code-analysis:
    + Add new tests.
  * tests/blackbox/pyflakes:
    + Remove tests for blacklisted tags

 -- Jakub Wilk <jwilk@debian.org>  Sun, 30 Mar 2014 21:30:39 +0200

lintian4python (0.27.2) experimental; urgency=low

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian (build-)dependency to support Lintian 2.5.22.

  * debian/source/options:
    + Use xz for tarball compression.

  * debian/tests:
    + Split the DEP-8 test into two separate ones: one for Python 2.X, another
      for Python 3.X.
    + Use the “allow-stderr” restriction, instead of redirecting stderr to
      stdout.

  * tests/blackbox/egg-info:
    + Update test for unknown-project-in-requires.txt.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 26 Mar 2014 22:17:32 +0100

lintian4python (0.27.1) experimental; urgency=low

  * debian/control:
    + Update lintian (build-)dependency to support Lintian 2.5.21
      (closes: #735141). Thanks to Martin Pitt for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 13 Jan 2014 13:25:40 +0100

lintian4python (0.27) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - regexp-duplicate-range
      - regexp-overlapping-ranges
      - regexp-syntax-error

  * data/python*-projects:
    + Update.

  * {checks,helpers}/python/code-analysis:
    + Check for syntax error in regular expressions.
    + Check for overlapping ranges in character sets in regular expressions.

  * private/update-coverage:
    + Take into account version-specific tests.

  * tests:
    + New tests.

  * tests/code-analysis:
    + Fix test failure with Python 3.4 (closes: #733164). Thanks to Dmitry
      Shachnev for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 07 Jan 2014 08:35:07 +0100

lintian4python (0.26) experimental; urgency=low

  * Summary of tag changes:
    + Added:
      - insufficient-any-dependency

  * data/python*-projects:
    + Update.

  * data/python-multi-arch-allowed:
    + New file containing versions of Python interpreters and metapackages
      that introduced “Multiarch: allowed” annotations.

  * checks/python/depends:
    + Tighten a regex.

  * checks/python/multi-arch:
    + Check for insufficient :any dependencies (see bug #723586).

  * helpers/python/code-analysis:
    + Check for errors in some str.format() calls.

  * tests:
    + New tests.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 25 Dec 2013 18:52:08 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,11 @@
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7)
 Build-Depends-Indep:
- lintian (>= 2.5.14~), lintian (<< 2.5.21~),
+ lintian (>= 2.5.14~), lintian (<< 2.5.23~),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
- python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.7.3+),
+ python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.8.1+),
+ python3-debian,
  python-all, python-nose,
  python3-all, python3-nose,
 XS-Testsuite: autopkgtest
@@ -19,10 +20,10 @@
 Package: lintian4python
 Architecture: all
 Depends: ${misc:Depends}, ${perl:Depends},
- lintian (>= 2.5.14~), lintian (<< 2.5.21~),
+ lintian (>= 2.5.14~), lintian (<< 2.5.23~),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
- python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.7.3+)
+ python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.8.1+)
 Recommends:
  python3
 Description: Debian package checker (for Python packages)

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,7 @@
 directories = checks helpers lib profiles vendors
 share = /usr/share/lintian/
 version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version))
+deb = lintian4python_$(version)_all.deb
 
 .PHONY: clean
 clean: debian/control
@@ -13,6 +14,8 @@
 ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
 build build-indep: debian/test-stamp
 debian/test-stamp:
+	./private/update-code-analysis-tags --dry-run
+	./private/update-pyflakes-tags --dry-run
 	$(MAKE) -C tests/code-analysis/ test-local
 	touch $(@)
 endif
@@ -37,14 +40,12 @@
 	dh_installdeb
 	dh_gencontrol
 	dh_md5sums
+	dh_builddeb
 ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
-	mkdir -p debian/tmp
-	dh_builddeb --destdir=debian/tmp
 	export LINTIAN_INTERNAL_TESTSUITE=1 && \
-	./lintian4py --allow-root --no-cfg debian/tmp/*.deb 2>&1 | ( ! grep . )
-	dpkg -f debian/tmp/*.deb Depends \
+	./lintian4py --allow-root --no-cfg ../$(deb) 2>&1 | ( ! grep . )
+	dpkg -f ../$(deb) Depends \
 	| xargs -t -d '\n' dpkg-checkbuilddeps -d
 endif
-	dh_builddeb
 
 # vim:ts=4 sw=4 noet

=== debian/tests/control ===
Tests: code-analysis-py2
Depends: lintian4python,
 make,
 python, python-nose
Restrictions: allow-stderr

Tests: code-analysis-py3
Depends: lintian4python,
 make,
 python3, python3-nose
Restrictions: allow-stderr

Tests: adequate
Depends: lintian4python, adequate

## lintian4python 0.28.4

=== debian/changelog ===
lintian4python (0.28.4) experimental; urgency=low

  * debian/control:
    + Update lintian (build-)dependency to support Lintian 2.5.26 and 2.5.27
      (closes: #761910). Thanks to Axel Beckert for the bug report.

  * debian/copyright:
    + Drop spurious trailing colon from a Fields header field.

  * data/python*-projects:
    + Update.

  * tests/blackbox/egg-info:
    + Update test for missing-requires.txt-optional-dependency.
    + Update test for unknown-optional-project-in-requires.txt.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 16 Sep 2014 22:26:47 +0200

lintian4python (0.28.3) experimental; urgency=low

  * checks/python/egg-info:
    + Update pkg_resources documentation URL.

  * checks/python/helpers:
    + Fix the “keys on reference is experimental” warning.

  * checks/python/*.desc:
    + Use HTTPS URLs when they are available.

  * data/python*-projects:
    + Update.

  * debian/copyright (and other files):
    + Use HTTPS when referring to the GNU website.

  * private/update-coverage:
    + Use glob.iglob(), instead of glob.glob(), in the place where a list is
      not needed.

  * private/update-exception-names:
    + Use HTTPS URLs.

  * tests/blackbox/*:
    + Use HTTPS URLs when they are available.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 18 Aug 2014 15:27:41 +0200

lintian4python (0.28.2) experimental; urgency=low

  * checks/python/*.desc:
    + Replace “index” with “unpacked” in Needs-Info.

  * data/python*-projects:
    + Update.

  * debian/control:
    + Update lintian (build-)dependency to support Lintian 2.5.25
      (closes: #756737). Thanks to Paul R. Tagliamonte for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 03 Aug 2014 20:22:40 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7)
 Build-Depends-Indep:
- lintian (>= 2.5.14~), lintian (<< 2.5.23~),
+ lintian (>= 2.5.25~), lintian (<< 2.5.28~),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
  python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.8.1+),
@@ -20,7 +20,7 @@
 Package: lintian4python
 Architecture: all
 Depends: ${misc:Depends}, ${perl:Depends},
- lintian (>= 2.5.14~), lintian (<< 2.5.23~),
+ lintian (>= 2.5.25~), lintian (<< 2.5.28~),
  libmonkey-patch-perl,
  perl (>= 5.10), libtext-levenshtein-perl, liblist-moreutils-perl, liburi-perl,
  python (>= 2.6), pyflakes (>= 0.6.1), pyflakes (<< 0.8.1+)
